---
id: sprint2
title: "Sprint 2: Product Integration "
sidebar_label: Sprint 2
slug: /sprint2
---


This sprint is aiming to study the product that needs to be deployed, what it is what it needs to work and how it is secured or needs
to be secured.

### What are the requirements for fully running Raven products and what are the security limitations of this product?
------------------------------------------------------

Raven is a **data enrichment**, **analytics**, and **flow management tool**. Because it handles data it needs to be properly secured in the environment that it is deployed.

It is easier to secure an application when you understand it well.


![img](../../static/img/RavenTopology.png)

Figure 1 - Raven inner working diagrams according to current working model

-----------------------------------------

As it can be seen in Figure 1 the main components of the system are raven-ingest, raven-workflow, raven-formation, and portal-api/portal-web services.
Each one **might** need its own VM. On top of that, there are some additional services that can and **should be deployed** together
with them. Such as **Consul**, **Docker**, and **Vault**. While they are just as important, they can be deployed together with one of the
existing machines.

Below there is a short description of each of the Raven services:

1.	**raven-workflow**
Workflow is the system responsibe for the concurrent queing of bricks, it is the data layer between the bricks.

2.	**consul**
This is the token management system that works together with vault.

3.	**raven-ingest**
The data ingestion part of the Raven it is a used as a caching system for data that is flowing through Raven. It is one of the most important parts and requires its own separate machine to function.

4.	**vault**
The token management system used from Hashicorp.

4.1	**Docker host**
On the same machine as raven-ingest it needs docker as some of the functionality of raven-ingest is deployed through docker containers.

5.	**raven-formation**
The container orchestration service that manages all the bricks.

6. **portal-api**
The service responsible for hosting the  backeend of the websiteand the api that is used by raven-formation.

After understanding the components that need to be deployed an actual plan of deployment and secuing all components needed to be drafted.

### What are the security features that are implemented in the current user environment and how can they be translated to the Azure environment?
---------------------------------------------------
![img](../../static/img/Topology.png)

[Figure 2 - Topology of proposed Azure environment]

----------------------------------------

After understanding the components that need to be deployed an actual plan of deployment and securing all components needed to be drafted.
In accordance with the research made in the first sprint and the conclusions made an appropriate solution was designed. The above topology
Figure 2 gives a good representation of the way a secure environment could be achieved for the Raven product deployment.

First and foremost **an image** must be created for the Virtual machines that will be deployed in Azure. In order to do this automatically
and securely the whole process is orchestrated through **Packer**, an open source tool for creating identical machine images.

To ensure that the machine that is running Raven is safe a first step that must be taken is creating a **custom image of Debian** and
provisioning it with **the necessary scripts and services** to run Raven.

![img](../../static/img/EnvVarGit.png)
[Figure 3 - Image of Gitlab environemt variables]

----------------------------------------
Furthermore, to manage this process everything is automated through the company **Gitlab pipeline** where all secure environment variables
or credentials are stored safe and sound from human eyes. Once the pipeline is run, **Packer** will temporarily create a machine in Azure
and then create an image based on that machine which is stored inside the [Azure](../../glossary#azure-cloud) Image service.

At this point, the image contains a machine with all the necessary setup functions and services to run Raven. Next using **Terraform**,
an open-source [IAC](../portofolio/iac), all the different elements of the Azure environment are created.

One **virtual network** with **virtual machines** containing the services needed to run Raven and another virtual network with Consul, a service mesh
the solution used to manage and monitor services across cloud platforms.

Each machine can be added inside a **Network Security Group**, which acts as a firewall for the machines. Here inbound and outbound
rules such as allowing SSH connections to access the machines for only the company WireGuard VPN IP or freeing up the ports for services such as MariaDB, Vault and
Consul to communicate with one another are necessary.

Because Raven itself stores credentials and valuable data all of it is secured through **Hashicorps Vault**,
which is a secrets management solution. Its purpose is to broker access for both humans and machines. Because Vault starts sealed, it needs to be
opened with the initialization root key, this can be stored in **Azure Key Vault**, a token storage system.

Furthermore, Raven itself needs to be **hosted and run** for people to access it. This can be achieved through **Front Door**. And of course,
making sure that all the activities inside the Azure environment **are monitored**, this is done through the Log Analytics service, which
combined with **Azure Event Hub** can send data to any system even to another instance of Raven to **monitor and analyze the data**.

On top of this, making sure that all machines have **minimal access**, is paramount to create custom roles for those machines through RBAC, to secure the identity access and
management system for Azure subscriptions which enables actions and tasks.


### What are the security requirements of the company and of the project?
-------------------------------

This question was best answered by interviewing the current maintainer of the infrastructure. That person
is my company mentor. To get a better understanding of the product, multiple question stages were created in accordance with the level of
knowledge acquired at each stage.

[Interview](../../static/documents/Interview.pdf)

The conclusions of the interview helped with defining the security requirements of the company:
- Implementing Consul and Vault for the Raven application
- Implementing monitoring for the Virtual machine or machines holding the services
- Creating appropriate security groups for the applications.

### Conclusions
-----------------------------

**How does Raven work?**

Raven is a multi-service application that needs all its components to work together in order to function. For each part of the
process configuration must be made and certain security measures must be taken, such as opening or closing access, monitoring the
services and granting minimal permissions. 

**Can Raven be run from a premade image?**

Because some of the services are dependent on each other and not all of them can be run on the same instance, creating a single image
that has Raven installed and ready to start is not a viable solution. That being said, it may not be a solution for market purposes but
it can be used for development and research purposes.

**How should the environment be set up?**

The deployment system is both dependents on the GitLab pipeline and on the Azure environment therefore the securing process must take
into consideration both environments. As such the GitLab environment must secure its credentials with the use of Hashicorp Vault and the Azure environment must
secure access to its resources and monitor their status through the use of Log analytics workspaces and similar Azure services.

--------------------


### [Interview](../../static/documents/Interview.pdf)

--------------



